Bug 786095

Summary: stripe volume on NFS mount point throws I/O error messages upon writes
Product: [Community] GlusterFS Reporter: shylesh <shmohan>
Component: nfsAssignee: shishir gowda <sgowda>
Status: CLOSED CURRENTRELEASE QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: mainlineCC: gluster-bugs, nsathyan
Target Milestone: ---   
Target Release: ---   
Hardware: x86_64   
OS: Linux   
Whiteboard:
Fixed In Version: glusterfs-3.4.0 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-07-24 13:25:13 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: 3.3.0qa36 Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 817967    

Description shylesh 2012-01-31 07:51:46 EST
Description of problem:
mounted a stripe volume on nfs mount throwing I/O errors 

Version-Release number of selected component (if applicable):
Mainline

How reproducible:
often

Steps to Reproduce:
1.created a stripe volume with  2 bricks
2. NFS mounted the volume 
3. ran the following command " cp /etc/passwd /mnt" 
  
Actual results:
I/O error

Expected results:


Additional info:


NFS logs
---------

, attached to remote volume '/export/sda/test2'.
[2012-01-31 07:14:47.060754] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: 9c68b160: /., => -1 (Invalid argument)
[2012-01-31 07:14:47.060811] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: 9c68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:14:50.135174] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: a068b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:14:50.135209] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: a068b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:22:56.965338] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: ad68b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:22:56.965446] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: ad68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:22:56.969680] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: ad68b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:22:56.969704] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: ad68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:22:56.969760] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: ad68b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:22:56.969777] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: ad68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:22:56.969830] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: ad68b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:22:56.969847] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: ad68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:24:14.834309] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: bb68b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:24:14.834392] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: bb68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:41:19.873193] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: c368b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:41:19.873260] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: c368b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066
[2012-01-31 07:41:33.318145] W [nfs3.c:2062:nfs3svc_write_cbk] 0-nfs: cc68b160: /passwd => -1 (Invalid argument)
[2012-01-31 07:41:33.318180] W [nfs3-helpers.c:3455:nfs3_log_write_res] 0-nfs-nfsv3: XID: cc68b160, WRITE: NFS: 22(Invalid argument for operation), POSIX: 22(Invalid argument), count: 0, UNSTABLE,wverf: 1328012066

================================================================


stripe_writev always hits 
3865            fd_ctx_get (fd, this, &tmp_fctx);
3866            if (!tmp_fctx) {
3867                    op_errno = EINVAL;
3868                    goto err;
3869            }
Comment 1 Anand Avati 2012-02-14 04:57:52 EST
CHANGE: http://review.gluster.com/2726 (cluster/stripe: Support for NFS anonymous fd's) merged in master by Vijay Bellur (vijay@gluster.com)
Comment 2 shylesh 2012-04-20 06:06:17 EDT
Works fine on 3.3.0qa36